
//import 'dart:html' as html;
import 'dart:collection';

class Storage extends MapBase<String,String> {

  bool get isInMemoryStorage => delegate is html.Storage;

  final Map<String,String> delegate;
  final String _prefix;

  _prefixedName(Object name) => name is String ? "$_prefix$name" : name;





  Storage.memory() : this.wrap(<String,String>{},"");
  Storage.wrap(this.delegate, [this._prefix = "firebase:"]);

  factory Storage(String domStorageName) {
    try {
      html.Storage domStorage = domStorageName=="localStorage" ? html.window.localStorage :
          domStorageName=="sessionStorage" ? html.window.sessionStorage : null;
      domStorage["firebase:sentinel"] = "cache";
      domStorage.remove("firebase:sentinel");
      return new Storage.wrap(domStorage);
    } catch (e) {
    }
    return new Storage.memory();
  }

  @override
  String operator [](Object key) => delegate[_prefixedName(key)];

  @override
  operator []=(String key, String value) => delegate[_prefixedName(key)] = value;

  @override
  void clear() => keys.toList().forEach((k)=>delegate.remove(k));

  @override
  Iterable<String> get keys => delegate.keys.where((k)=>k.startsWith(_prefix));

  @override
  String remove(Object key) => delegate.remove(_prefixedName(key));

}

final persistentStorage = new Storage("localStorage");
final sessionStorage = new Storage("sessionStorage");
