
library firebase_dart.src.dart.core.util.validation;

import 'package:firebase_dart/src/dart/util/validation.dart';


final _INVALID_KEY_REGEX = new RegExp(r"[\[\].#$\/\u0000-\u001F\u007F]");
final _INVALID_PATH_REGEX = new RegExp(r"[\[\].#$\u0000-\u001F\u007F]");
final _VALID_AUTH_PROVIDER = new RegExp(r"^[a-zA-Z][a-zA-Z._\-+]+$");
const MAX_LEAF_SIZE_= 10 * 1024 * 1024;


validatePathString(String fnName, int argumentNumber, String pathString, bool optional) {
  if (optional && pathString==null) return;
  if (!isValidPathString(pathString)) {
    throw new Exception(errorPrefix(fnName, argumentNumber, optional) +
        'was an invalid path: "' + pathString +
        '". Paths must be non-empty strings and ' +
        'can\'t contain ".", "#", "\$", "[", or "]"');
  }
}

isValidPathString(String pathString) {
  return pathString.isNotEmpty && !_INVALID_PATH_REGEX.hasMatch(pathString);
}